Summary:     Berkeley Internet Name Domain server
Name:        bind
Version:     9.3.2
Release:     10.rh73.pp
Epoch:       30
License:     GPL
Group:       System Environment/Daemons
Source0:     ftp://ftp.isc.org/isc/%{name}9/%{version}/%{name}-%{version}.tar.gz
Source1:     http://www.venaas.no/ldap/%{name}-sdb/%{name}-sdb-ldap-1.1.0.tar.gz
Source2:     named.init
Source3:     lwresd.init
Source4:     named-etc.tar.gz
Source5:     named-var.tar.gz
Source6:     named.sysconfig
Source7:     http://www.venaas.no/ldap/%{name}-sdb/dnszone-schema.txt
Source8:     http://mysql-bind.sourceforge.net/mysql-bind-0-1.tgz
Patch0:      %{name}-%{version}-path.patch
Patch1:      %{name}-9.3.1-nmbr_processors.patch
Patch2:      %{name}-%{version}-sdb-notify.patch
Patch3:      %{name}-%{version}-sdb-addown.patch
Patch4:      %{name}-%{version}-sdb-driver.patch
Patch5:      %{name}-%{version}-contrib-zone2ldap.patch
Patch6:      %{name}-%{version}-contrib-zone2pgsql.patch
Patch7:      %{name}-sdb-bdb-build.patch
Patch8:      %{name}-sdb-pgsql-build.patch
Patch9:      %{name}-sdb-ldap-1.1.0-bindfix.patch
Patch10:     %{name}-sdb-ldap-1.1.0-ldapinit.patch
URL:         http://www.isc.org/products/BIND/
Buildroot:   /var/tmp/%{name}-root
Vendor:      ISC
Packager:    Peter Pramberger <peter.pramberger@member.fsf.org>
Provides:    %{name}.pp
Requires:    %{name}-libs = %{epoch}:%{version}-%{release} %{name}-libs.pp
Requires:    %{name}-utils = %{epoch}:%{version}-%{release} %{name}-utils.pp
Conflicts:   %{name}-lwresd
Prereq:      fileutils findutils glibc make shadow-utils
BuildPrereq: fileutils findutils glibc-devel gcc make perl
#BuildPrereq:db4-devel mysql-devel openldap22-devel openssl097-devel
BuildPrereq: mysql-devel openldap22-devel openssl097-devel
BuildPrereq: postgresql-devel
BuildConflicts: %{name}-libs
ExclusiveOS: linux

%description
The Berkeley Internet Name Domain (BIND) implements an
Internet name server for Unix operating systems. The BIND
consists of a server (or `daemon') called `named' and a
resolver library. A name server is a network service that
enables clients to name resources or objects and share this
information with other objects in the network.


%package devel
Summary:     Development tools for the BIND server
Group:       Development/Libraries
Provides:    %{name}-devel.pp
Requires:    %{name}-libs = %{epoch}:%{version}-%{release} %{name}-libs.pp

%package libs
Summary:     Libraries used by various DNS packages
Group:       System Environment/Libraries
Provides:    %{name}-libs.pp
Requires:    openssl097

%package lwresd
Summary:     The new lightweight resolver daemon
Group:       System Environment/Daemons
Provides:    %{name}-lwresd.pp
Requires:    %{name}-libs = %{epoch}:%{version}-%{release} %{name}-libs.pp
Requires:    %{name}-utils = %{epoch}:%{version}-%{release} %{name}-utils.pp
Conflicts:   %{name}

%package sdb
Summary:     BIND with additional SDB support
Group:       System Environment/Daemons
Provides:    %{name}-sdb.pp
Requires:    %{name} = %{epoch}:%{version}-%{release} %{name}.pp
Requires:    %{name}-libs = %{epoch}:%{version}-%{release} %{name}-libs.pp
Requires:    %{name}-utils = %{epoch}:%{version}-%{release} %{name}-utils.pp
#Requires:   db4 mysql openldap22 postgresql-libs
Requires:    mysql openldap22 postgresql-libs

%package utils
Summary:     Utilities for querying DNS name servers
Group:       Applications/Internet
Provides:    %{name}-utils.pp
Requires:    %{name}-libs = %{epoch}:%{version}-%{release} %{name}-libs.pp


%description devel
The %{name}-devel package contains the static libraries and
header files for developing software for bind.

%description libs
The %{name}-libs package contains libraries used by both the
bind server package as well as the utils packages.

%description lwresd
The %{name}-lwresd package includes the new lightweight stub
resolver daemon which in conjunction with the resolver library
is supporting forward and reverse lookups of both IPv4 and
IPv6 addresses. This part is considered experimental and is
not a complete replacement for the BIND8 resolver library.
Applications that use the BIND8 res_* functions to perform
DNS lookups or dynamic updates still need to be linked against
the BIND8 libraries.

%description sdb
The %{name}-sdb package includes a named with support for
serving zone data via directory structure, LDAP or databases.

%description utils
The %{name}-utils package contains a collection of utilities
for querying DNS (Domain Name Service) name servers to find
out information about Internet hosts. These tools will provide
the IP addresses for given host names, as well as other data
about registered domains and network addresses. These tools
also support IDN.


%prep
%setup -q -a 1 -a 8
# path adjustment
%patch0 -p1 -b .path
# get number of processors fix
#%patch1 -p1 -b .nmbrprocs
# IDN support
patch -p0 -b --suffix .idn < contrib/idn/idnkit-1.0-src/patch/%{name}9/%{name}-%{version}-patch
cp -p bin/named/main.c bin/named/main_sdb.c
# SDB support
%patch2 -p1 -b .sdbnotify
%patch3 -p1 -b .sdbaddown
%patch4 -p1 -b .sdbdriver
# SDB BerkeleyDB
#%patch7 -p0 -b .buildbdb
# SDB LDAP
%patch5 -p0 -b .buildz2l
%patch9 -p0 -b .bindfix
%patch10 -p0 -b .ldapinit
# SDB PostgreSQL
%patch6 -p0 -b .buildz2p
%patch8 -p0 -b .buildpg
# SDB BerkeleyDB
#cp contrib/sdb/bdb/bdb.c bin/named
#cp contrib/sdb/bdb/bdb.h bin/named/include
#cp contrib/sdb/bdb/README README.bdb
#cp contrib/sdb/bdb/zone2bdb.c .
# SDB Directory
cp contrib/sdb/dir/dirdb.c bin/named
cp contrib/sdb/dir/dirdb.h bin/named/include
# SDB MySQL
cp mysql-bind*/mysqldb.c bin/named
cp mysql-bind*/mysqldb.h bin/named/include
cp mysql-bind*/ChangeLog ChangeLog.mysql
cp mysql-bind*/README README.mysql
cp mysql-bind*/zonetodb.c zone2mysql.c
# SDB LDAP
cp bind-sdb-ldap*/ldapdb.c bin/named
cp bind-sdb-ldap*/ldapdb.h bin/named/include
cp bind-sdb-ldap*/README README.ldap
cp bind-sdb-ldap*/INSTALL INSTALL.ldap
cp contrib/sdb/ldap/zone2ldap.c .
cp %{SOURCE7} .
# SDB PostgreSQL
cp contrib/sdb/pgsql/pgsqldb.c bin/named
cp contrib/sdb/pgsql/pgsqldb.h bin/named/include
cp contrib/sdb/pgsql/zonetodb.c zone2pgsql.c

# correct path to perl
for file in `find . -type f -exec fgrep -l /bin/perl {} \;`; do
  perl -i -pe 's+/(user|usr)/local/bin/perl+%{__perl}+g' ${file}
done


%build
CFLAGS="${RPM_OPT_FLAGS} -Wall -pipe"
export CFLAGS

# Build IDN library and tools
IDNKITDIR="`pwd`/idnkit-install"
mkdir -p ${IDNKITDIR}
pushd contrib/idn/idnkit-1.0-src
./configure \
	--prefix=%{_prefix}         \
	--sysconfdir=%{_sysconfdir} \
	--localstatedir=%{_localstatedir}/%{_lib}/named \
	--mandir=%{_mandir}         \
	--enable-mdnkit-compat      \
	--enable-extra-ace          \
	--enable-runidn             \
	--enable-shared             \
	--enable-static
make all
make DESTDIR=${IDNKITDIR} install
popd

# prevent libtool packaging build relink problem
export CFLAGS="${CFLAGS} -L${RPM_BUILD_ROOT}%{_libdir}"

# Build BIND
./configure \
	--prefix=%{_prefix}               \
	--sysconfdir=%{_sysconfdir}/named \
	--localstatedir=%{_localstatedir}/%{_lib}/named \
	--mandir=%{_mandir}               \
	--with-openssl=%{_prefix}         \
	--with-randomdev=/dev/urandom     \
	--enable-threads                  \
	--enable-largefile                \
	--with-libtool                    \
	--disable-libbind                 \
	--enable-shared                   \
	--enable-static                   \
	--enable-ipv6                     \
	--with-idn=${IDNKITDIR}%{_prefix}
make depend
make all

# Build SDB tools
build_sdbtool() {
gcc \
	-I%{_includedir}             \
	-Ilib/dns/include            \
	-Ilib/isc/include            \
	-Ilib/isc/unix/include       \
	-Ilib/isc/pthreads/include   \
	${2}                         \
	-D_REENTRANT                 \
	-c ${1}.c

gcc \
	-Llib/dns/.libs -ldns        \
	-Llib/isc/.libs -lisc        \
	-L%{_libdir} -lnsl -lpthread \
	${3}                         \
	${1}.o -o ${1}
}

#build_sdbtool zone2bdb
build_sdbtool zone2mysql "-I%{_includedir}/mysql" "-L%{_libdir}/mysql -lmysqlclient"
build_sdbtool zone2ldap  "" "-lldap -llber -lcrypto"
build_sdbtool zone2pgsql "" "-lpq"


# Do not strip, only compress documentation
%define __os_install_post /usr/lib/rpm/brp-compress


%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_initrddir}
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/{named,sysconfig}
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/{%{_lib},log,run}/named
make \
	DESTDIR=${RPM_BUILD_ROOT} \
	install
install -m 0755 {zone2mysql,zone2ldap,zone2pgsql} ${RPM_BUILD_ROOT}%{_bindir}
install -m 0644 contrib/sdb/ldap/zone2ldap.1 ${RPM_BUILD_ROOT}%{_mandir}/man1

pushd contrib/idn/idnkit-1.0-src
make \
	DESTDIR=${RPM_BUILD_ROOT} \
	install
popd

chmod 0755 ${RPM_BUILD_ROOT}%{_libdir}/*.so*
install -m 0755 %{SOURCE2} ${RPM_BUILD_ROOT}%{_initrddir}/named
install -m 0755 %{SOURCE3} ${RPM_BUILD_ROOT}%{_initrddir}/lwresd
install -m 0644 %{SOURCE6} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/named

IDNKITDIR="`pwd`/idnkit-install"
perl -i -pe "s+  -I${IDNKITDIR}%{_includedir}  ++g" ${RPM_BUILD_ROOT}%{_bindir}/isc-config.sh

tar xzf %{SOURCE4} -C ${RPM_BUILD_ROOT}%{_sysconfdir}/named
tar xzf %{SOURCE5} -C ${RPM_BUILD_ROOT}%{_localstatedir}/%{_lib}/named

# We do not want them in the doc dir!
find doc -name CVS -depth -exec rm -rf {} \;
find doc -name .cvsignore -depth -exec rm -f {} \;
find doc -name "Makefile*" -exec rm -f {} \;
find doc -name "*.in" -exec rm -f {} \;


%pre utils
if ! id -g named > /dev/null 2>&1; then
  groupadd -r -g 25 named
fi
if ! id -u named > /dev/null 2>&1; then
  useradd -u 25 -g named -G named \
	-d %{_localstatedir}/%{_lib}/named \
	-r -s /sbin/nologin named
fi


%post
chown -R named:named %{_localstatedir}/{%{_lib},log,run}/named
chmod 0750 %{_localstatedir}/{%{_lib},log,run}/named
find %{_localstatedir}/%{_lib}/named -type d -exec chmod 0750 {} \;
find %{_localstatedir}/%{_lib}/named -type f -exec chmod 0640 {} \;
if [ $1 = 1 ]; then
  chkconfig --add named
  chkconfig named on
fi
if [ -s %{_sysconfdir}/named/named.conf ]; then
  if [ -f %{_localstatedir}/lock/subsys/named ]; then
    %{_initrddir}/named restart
  fi
fi

%post libs
ldconfig

%post lwresd
chown named:named %{_localstatedir}/{log,run}/named
chmod 0750 %{_localstatedir}/{log,run}/named
if [ $1 = 1 ]; then
  chkconfig --add lwresd
  chkconfig lwresd on
fi
if [ -f %{_localstatedir}/lock/subsys/lwresd ]; then
  %{_initrddir}/lwresd restart
fi

%post sdb
chown -R named:named %{_localstatedir}/{%{_lib},log,run}/named
chmod 0750 %{_localstatedir}/{%{_lib},log,run}/named
find %{_localstatedir}/%{_lib}/named -type d -exec chmod 0750 {} \;
find %{_localstatedir}/%{_lib}/named -type f -exec chmod 0640 {} \;
if [ -s %{_sysconfdir}/named/named.conf ]; then
  if [ -f %{_localstatedir}/lock/subsys/named_sdb ]; then
    %{_initrddir}/named restart
  fi
fi

%post utils
chown root:named %{_sysconfdir}/named
chmod 0750 %{_sysconfdir}/named
if [ -f %{_sysconfdir}/named/rndc.key ]; then
  chown named:root %{_sysconfdir}/named/rndc.key
  chmod 0600 %{_sysconfdir}/named/rndc.key
else
  rndc-confgen -a -b 256 -u named
fi


%preun
if [ $1 = 0 ]; then
  chkconfig named off
  chkconfig --del named
  if [ -f %{_localstatedir}/lock/subsys/named ]; then
    %{_initrddir}/named stop
  fi
fi

%preun lwresd
if [ $1 = 0 ]; then
  chkconfig lwresd off
  chkconfig --del lwresd
  if [ -f %{_localstatedir}/lock/subsys/lwresd ]; then
    %{_initrddir}/lwresd stop
  fi
fi

%preun sdb
if [ $1 = 0 ]; then
  if [ -f %{_localstatedir}/lock/subsys/named_sdb ]; then
    %{_initrddir}/named stop
  fi
fi


%postun libs
ldconfig


%clean
rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc CHANGES COPYRIGHT FAQ INSTALL* README* dnszone-schema.txt
%doc contrib/sdb/ldap/README.zone2ldap
%doc %dir doc
%attr(640,root,named) %{_sysconfdir}/named/*.sample
%{_initrddir}/named
%{_mandir}/man5/named*
%{_mandir}/man8/named*
%{_mandir}/man8/dnssec*
%{_sbindir}/named
%{_sbindir}/named-check*
%{_sbindir}/dnssec*
%attr(750,named,named) %dir %{_localstatedir}/run/named
%attr(750,named,named) %dir %{_localstatedir}/log/named
%attr(750,named,named) %dir %{_localstatedir}/%{_lib}/named
%attr(-,named,named) %config(noreplace) %{_localstatedir}/%{_lib}/named/*

%files devel
%defattr(-,root,root)
%{_bindir}/isc-config.sh
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/*.*a
%{_mandir}/man3/*

%files libs
%defattr(-,root,root)
%{_libdir}/*.so.*

%files lwresd
%defattr(-,root,root)
%{_initrddir}/lwresd
%{_mandir}/man8/lwresd*
%{_sbindir}/lwresd
%attr(750,named,named) %dir %{_localstatedir}/run/named
%attr(750,named,named) %dir %{_localstatedir}/log/named

%files sdb
%defattr(-,root,root)
%{_bindir}/zone2*
%{_sbindir}/named_sdb

%files utils
%defattr(-,root,root)
%attr(-,root,named) %dir %{_sysconfdir}/named
%config %{_sysconfdir}/idn*.conf
%{_sysconfdir}/idn*.conf.sample
%config(noreplace) %{_sysconfdir}/sysconfig/named
%{_bindir}/dig
%{_bindir}/host
%{_bindir}/ns*
%{_bindir}/*idn*
%{_bindir}/*mdn*
%dir %{_datadir}/idnkit
%{_datadir}/idnkit/*
%{_mandir}/man1/*
%{_mandir}/man5/rndc*
%{_mandir}/man5/idn*
%{_mandir}/man5/mdn*
%{_mandir}/man8/ns*
%{_mandir}/man8/rndc*
%{_sbindir}/rndc*


%changelog
* Wed Dec 21 2005 peter.pramberger@member.fsf.org
- new version 9.3.2

* Wed Oct 19 2005 peter.pramberger@member.fsf.org
- added sdb enable-notify patch
- added new subpackage for sdb-enabled bind
- added sdb-support for MySQL and PostgreSQL
- some bugfixes

* Sat Oct 15 2005 peter.pramberger@member.fsf.org
- added sdb-ldap rebind patch
- added sdb-ldap reload patch
- some spec file cleanups

* Fri Sep 09 2005 peter.pramberger@member.fsf.org
- created

